.TH Calend 1 22/8/96

.SH NAME
C A L E N D A R - Print a Calendar

.SH SYNOPSIS     
  calend [year] [month]

       calend  MM        If small, it's a month, if large, a year.
  or
       calend  YYYY MM   year/month
  or
       calend  MM YYYY   month/year



.SH Description
When invoked without arguments, calend prints a
calendar for the preceeding, current, and next
months of the current year.

If a month is given (a value from 1 through 12),
it prints the three months centered on the requested
month.  For example,

            calend 12

Prints November and December for this year, and
January for next year.

If a year is given, it prints a calendar for the
entire year:

            calend 1985

If both values are given, it prints the three months
centered on the indicated date:

            calend 1752 9
            calend 9 1752

Note that a three or four digit number will always be taken 
as a year.  A one or two digit number will be either a month
or a year in the 20th century:

            calend 78           (equals calend 1978)
            calend 0078         (early common era)


.SH Author
Martin Minow
