#!/bin/sh
# tests of program greg  (Bourne shell script)

cal 12 1985 # delete this line if you don't have cal to run
echo smoke test
echo greg 1985	12	10  # birthday for this program
greg 1985	12	10  # birthday for this program
echo $? -----end of test---------------------------------------------------

echo test input validity checking capability
echo 1985	12	10	  3	2	   344	2446410
greg 1985	12	10	  3	2	   344	2446410
echo $? -----end of test---------------------------------------------------

echo test various input inversions
echo 1985	 0	 0	  0	0	   344	0
greg 1985	 0	 0	  0	0	   344	0
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	   0	2446410
greg 0		 0	 0	  0	0	   0	2446410
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	1	   0	
greg 1985	12	 0	  3	1	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	2	   0	
greg 1985	12	 0	  3	2	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	3	   0	
greg 1985	12	 0	  3	3	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	4	   0	
greg 1985	12	 0	  3	4	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	5	   0	
greg 1985	12	 0	  3	5	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	6	   0	
greg 1985	12	 0	  3	6	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  3	7	   0	
greg 1985	12	 0	  3	7	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  7	6	   0	
greg 1985	12	 0	  7	6	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	11	 0	  1	1	   0	
greg 1985	11	 0	  1	1	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  3	0	   344	
greg 1985	12	10	  3	0	   344	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  0	2	   0	
greg 1985	12	10	  0	2	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  0	3	   0	
greg 1985	12	10	  0	3	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  2	0	   0	
greg 1985	12	10	  2	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  0	0	   344	
greg 1985	12	10	  0	0	   344	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 0	  0	0	   344	
greg 1985	12	 0	  0	0	   344	
echo $? -----end of test---------------------------------------------------
echo 1985	 0	10	  0	0	   344	
greg 1985	 0	10	  0	0	   344	
echo $? -----end of test---------------------------------------------------
echo 1985	12	10	  0	0	   345	
greg 1985	12	10	  0	0	   345	
echo $? -----end of test---------------------------------------------------

echo test first of a bunch of months
echo 1985	 1	 1	  0	0	   0	
greg 1985	 1	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 2	 1	  0	0	   0	
greg 1985	 2	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 3	 1	  0	0	   0	
greg 1985	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 4	 1	  0	0	   0	
greg 1985	 4	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 5	 1	  0	0	   0	
greg 1985	 5	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 6	 1	  0	0	   0	
greg 1985	 6	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 7	 1	  0	0	   0	
greg 1985	 7	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 8	 1	  0	0	   0	
greg 1985	 8	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	 9	 1	  0	0	   0	
greg 1985	 9	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	10	 1	  0	0	   0	
greg 1985	10	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	11	 1	  0	0	   0	
greg 1985	11	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1985	12	 1	  0	0	   0	
greg 1985	12	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------

echo test funny leap years
cal 3 2000 # delete this line if you don't have cal to run
echo 2000	 3	 1	  0	0	   0	
greg 2000	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
cal 3 1900 # delete this line if you don't have cal to run
echo 1900	 3	 1	  0	0	   0	
greg 1900	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
cal 3 1952 # delete this line if you don't have cal to run
echo 1952	 3	 1	  0	0	   0	
greg 1952	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
cal 3 1953 # delete this line if you don't have cal to run
echo 1953	 3	 1	  0	0	   0	
greg 1953	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
cal 3 1954 # delete this line if you don't have cal to run
echo 1954	 3	 1	  0	0	   0	
greg 1954	 3	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------

echo test first and last day
cal 1984 # delete this line if you don't have cal to run
echo 1984	 1	 1	  0	0	   0	
greg 1984	 1	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	12	31	  0	0	   0	
greg 1984	12	31	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 0	 0	  0	0	   1	
greg 1984	 0	 0	  0	0	   1	
echo $? -----end of test---------------------------------------------------
echo 1984	 0	 0	  0	0	   366	
greg 1984	 0	 0	  0	0	   366	
echo $? -----end of test---------------------------------------------------

echo violate various calendar limitations
echo 1984	 0	 0	  0	0	   367	
greg 1984	 0	 0	  0	0	   367	
echo $? -----end of test---------------------------------------------------
echo 1984	13	 1	  0	0	   0	
greg 1984	13	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------

echo thoroughly test a February
echo 1984	 2	 1	  0	0	   0	
greg 1984	 2	 1	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 2	  0	0	   0	
greg 1984	 2	 2	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 3	  0	0	   0	
greg 1984	 2	 3	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 4	  0	0	   0	
greg 1984	 2	 4	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 5	  0	0	   0	
greg 1984	 2	 5	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 6	  0	0	   0	
greg 1984	 2	 6	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 7	  0	0	   0	
greg 1984	 2	 7	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 8	  0	0	   0	
greg 1984	 2	 8	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 9	  0	0	   0	
greg 1984	 2	 9	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	10	  0	0	   0	
greg 1984	 2	10	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	11	  0	0	   0	
greg 1984	 2	11	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	12	  0	0	   0	
greg 1984	 2	12	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	13	  0	0	   0	
greg 1984	 2	13	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	14	  0	0	   0	
greg 1984	 2	14	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	15	  0	0	   0	
greg 1984	 2	15	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	16	  0	0	   0	
greg 1984	 2	16	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	17	  0	0	   0	
greg 1984	 2	17	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	18	  0	0	   0	
greg 1984	 2	18	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	19	  0	0	   0	
greg 1984	 2	19	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	20	  0	0	   0	
greg 1984	 2	20	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	21	  0	0	   0	
greg 1984	 2	21	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	22	  0	0	   0	
greg 1984	 2	22	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	23	  0	0	   0	
greg 1984	 2	23	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	24	  0	0	   0	
greg 1984	 2	24	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	25	  0	0	   0	
greg 1984	 2	25	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	26	  0	0	   0	
greg 1984	 2	26	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	27	  0	0	   0	
greg 1984	 2	27	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	28	  0	0	   0	
greg 1984	 2	28	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	29	  0	0	   0	
greg 1984	 2	29	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo should fail
echo 1985	 2	29	  0	0	   0	
greg 1985	 2	29	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo 1984	 2	30	  0	0	   0	
greg 1984	 2	30	  0	0	   0	
echo $? -----end of test---------------------------------------------------
echo test around March 1 and invert wrt julian day
echo 1984	 0	 0	  0	0	   59	
greg 1984	 0	 0	  0	0	   59	
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	    0	2445759
greg 0		 0	 0	  0	0	    0	2445759
echo $? -----end of test---------------------------------------------------
echo 1984	 0	 0	  0	0	   60	
greg 1984	 0	 0	  0	0	   60	
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	    0	2445760
greg 0		 0	 0	  0	0	    0	2445760
echo $? -----end of test---------------------------------------------------
echo 1984	 0	 0	  0	0	   61	
greg 1984	 0	 0	  0	0	   61	
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	    0	2445761
greg 0		 0	 0	  0	0	    0	2445761
echo $? -----end of test---------------------------------------------------
echo 1984	 2	 0	  0	0	   61	
greg 1984	 2	 0	  0	0	   61	
echo $? -----end of test---------------------------------------------------

echo known Julian Days
echo '2446066.5  == Jan 1.0 1985 GMT: the Astronomical Ephemeris'
echo "2446065.5  == 0000 hours Jan 0 1985:  Observer's Handbook 1985 pg 20"
echo '2446065    == 12n GMT 12/31/84: 1985 World Almanac pg 751 (wrong)'
echo 1984	 12	 31	  0	0	   0	2446066
greg 1984	 12	 31	  0	0	   0	2446066
echo $? -----end of test---------------------------------------------------
echo '2446430    == 12n GMT 12/31/85: 1986 World Almanac pg 751 (wrong)'
echo 1985	 12	 31	  0	0	   0	2446430
greg 1985	 12	 31	  0	0	   0	2446430
echo $? -----end of test---------------------------------------------------
cal 3 1900 # delete this line if you don't have cal to run
echo 'from Tantzen paper k=1'
echo 1900	 3	 1	  0	0	   0	2415080
greg 1900	 3	 1	  0	0	   0	2415080
echo $? -----end of test---------------------------------------------------
cal 12 1999 # delete this line if you don't have cal to run
echo 'from Tantzen paper k=36465'
echo 1999	 12	 31	  0	0	   0	2451544
greg 1999	 12	 31	  0	0	   0	2451544
echo $? -----end of test---------------------------------------------------
echo '2440587.5 == Jan 1.0 1970 GMT: Astronomical Ephemeris'
echo '2440588   == 12n 1/1/70: Fliegel paper'
cal 1 1970 # delete this line if you don't have cal to run
echo 1970	 1	 1	  0	0	   0	2440588
greg 1970	 1	 1	  0	0	   0	2440588
echo $? -----end of test---------------------------------------------------
echo '2305813   == Bhaskar correction to error in submitted version'
echo 1600	12	31	  0	0	   0	2305813
greg 1600	12	31	  0	0	   0	2305813
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	   0	2305812
greg 0		 0	 0	  0	0	   0	2305812
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	   0	2305813
greg 0		 0	 0	  0	0	   0	2305813
echo $? -----end of test---------------------------------------------------
echo 0		 0	 0	  0	0	   0	2305814
greg 0		 0	 0	  0	0	   0	2305814
echo $? -----end of test---------------------------------------------------

echo white box magic constants
echo Jan 0 0001 +- 1
echo 	0	 0	 0	  0	0	   0	1721424
greg 	0	 0	 0	  0	0	   0	1721424
echo $? -----end of test---------------------------------------------------
echo 	0	 0	 0	  0	0	   0	1721425
greg 	0	 0	 0	  0	0	   0	1721425
echo $? -----end of test---------------------------------------------------
echo 	0	 0	 0	  0	0	   0	1721426
greg 	0	 0	 0	  0	0	   0	1721426
echo $? -----end of test---------------------------------------------------

echo Oct 15 1582 +-1
echo 	0	 0	 0	  0	0	   0	2299160
greg 	0	 0	 0	  0	0	   0	2299160
echo $? -----end of test---------------------------------------------------
echo 	0	 0	 0	  0	0	   0	2299161
greg 	0	 0	 0	  0	0	   0	2299161
echo $? -----end of test---------------------------------------------------
echo 	0	 0	 0	  0	0	   0	2299162
greg 	0	 0	 0	  0	0	   0	2299162
echo $? -----end of test---------------------------------------------------

echo try a very big year just for the fun of it
echo 	5000000 1 1
greg 	5000000 1 1
echo $? -----end of test---------------------------------------------------

echo test bad parameters
echo	no parameters					
greg	# empty					
echo $? -----end of test---------------------------------------------------
echo    1	 0	 0	  0	0	   0	    0	0 # too many
greg    1	 0	 0	  0	0	   0	    0	0
echo $? -----end of test---------------------------------------------------
echo   -1	 0	 0	  0	0	   0	# negative year
greg   -1	 0	 0	  0	0	   0	
echo $? -----end of test---------------------------------------------------

echo 'end of tests'
